From 54de31e5a7f922e292af8f556acd99ae4034ce10 Mon Sep 17 00:00:00 2001
From: Zhijie Hou <houzj.fnst@fujitsu.com>
Date: Thu, 28 Aug 2025 13:51:28 +0800
Subject: [PATCH v3 2/2] PG17 Fix replica identity check for INSERT ON CONFLICT

This commit enforces proper checks for INSERT ON CONFLICT DO UPDATE command to
determine if it can be executed with current replica identity. Previously, only
the executability of the INSERT command was validated, missing checks for the
UPDATE operations that can occur within this command. To fix it, validate the
executability of the UPDATE operation as part of the ON CONFLICT DO UPDATE
command.
---
 src/backend/executor/execMain.c           | 26 +++++++++++++++++++++--
 src/backend/executor/execPartition.c      |  9 ++++++--
 src/backend/executor/nodeModifyTable.c    |  3 ++-
 src/include/executor/executor.h           |  3 +++
 src/test/regress/expected/publication.out | 23 ++++++++++++++++++++
 src/test/regress/sql/publication.sql      | 26 +++++++++++++++++++++++
 6 files changed, 85 insertions(+), 5 deletions(-)

diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index ac63326abaa..894dc2d3c85 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -1012,12 +1012,15 @@ InitPlan(QueryDesc *queryDesc, int eflags)
  * result relation is required to support every action, regardless of whether
  * or not they are all executed.
  *
+ * For INSERT ON CONFLICT, the result relation is required to support the
+ * onConflictAction, regardless of whether a conflict actually occurs.
+ *
  * Note: when changing this function, you probably also need to look at
  * CheckValidRowMarkRel.
  */
 void
-CheckValidResultRel(ResultRelInfo *resultRelInfo, CmdType operation,
-					List *mergeActions)
+CheckValidResultRelNew(ResultRelInfo *resultRelInfo, CmdType operation,
+					   List *mergeActions, OnConflictAction onConflictAction)
 {
 	Relation	resultRel = resultRelInfo->ri_RelationDesc;
 	FdwRoutine *fdwroutine;
@@ -1041,6 +1044,13 @@ CheckValidResultRel(ResultRelInfo *resultRelInfo, CmdType operation,
 					CheckCmdReplicaIdentity(resultRel, action->commandType);
 			else
 				CheckCmdReplicaIdentity(resultRel, operation);
+
+			/*
+			 * For INSERT ON CONFLICT DO UPDATE, additionally verify whether
+			 * the UPDATE can be executed for the target relation.
+			 */
+			if (onConflictAction == ONCONFLICT_UPDATE)
+				CheckCmdReplicaIdentity(resultRel, CMD_UPDATE);
 			break;
 		case RELKIND_SEQUENCE:
 			ereport(ERROR,
@@ -1131,6 +1141,18 @@ CheckValidResultRel(ResultRelInfo *resultRelInfo, CmdType operation,
 	}
 }
 
+/*
+ * ABI-compatible wrapper to emulate old version of the above function.
+ * Do not call this version in new code.
+ */
+void
+CheckValidResultRel(ResultRelInfo *resultRelInfo, CmdType operation,
+					List *mergeActions)
+{
+	return CheckValidResultRelNew(resultRelInfo, operation, mergeActions,
+								  ONCONFLICT_NONE);
+}
+
 /*
  * Check that a proposed rowmark target relation is a legal target
  *
diff --git a/src/backend/executor/execPartition.c b/src/backend/executor/execPartition.c
index a3602b81687..6433d55a63f 100644
--- a/src/backend/executor/execPartition.c
+++ b/src/backend/executor/execPartition.c
@@ -357,8 +357,12 @@ ExecFindPartition(ModifyTableState *mtstate,
 											   true, false);
 				if (rri)
 				{
+					ModifyTable *node = (ModifyTable *) mtstate->ps.plan;
+
 					/* Verify this ResultRelInfo allows INSERTs */
-					CheckValidResultRel(rri, CMD_INSERT, NIL);
+					CheckValidResultRelNew(rri, CMD_INSERT, NIL, node
+										   ? node->onConflictAction
+										   : ONCONFLICT_NONE);
 
 					/*
 					 * Initialize information needed to insert this and
@@ -524,7 +528,8 @@ ExecInitPartitionInfo(ModifyTableState *mtstate, EState *estate,
 	 * partition-key becomes a DELETE+INSERT operation, so this check is still
 	 * required when the operation is CMD_UPDATE.
 	 */
-	CheckValidResultRel(leaf_part_rri, CMD_INSERT, NIL);
+	CheckValidResultRelNew(leaf_part_rri, CMD_INSERT, NIL,
+						   node ? node->onConflictAction : ONCONFLICT_NONE);
 
 	/*
 	 * Open partition indices.  The user may have asked to check for conflicts
diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index c230b666706..9ef59fa9479 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -4531,7 +4531,8 @@ ExecInitModifyTable(ModifyTable *node, EState *estate, int eflags)
 		/*
 		 * Verify result relation is a valid target for the current operation
 		 */
-		CheckValidResultRel(resultRelInfo, operation, mergeActions);
+		CheckValidResultRelNew(resultRelInfo, operation, mergeActions,
+							   node->onConflictAction);
 
 		resultRelInfo++;
 		i++;
diff --git a/src/include/executor/executor.h b/src/include/executor/executor.h
index 7e6e366ceac..bea80e36f00 100644
--- a/src/include/executor/executor.h
+++ b/src/include/executor/executor.h
@@ -211,6 +211,9 @@ extern void ExecutorRewind(QueryDesc *queryDesc);
 extern bool ExecCheckPermissions(List *rangeTable,
 								 List *rteperminfos, bool ereport_on_violation);
 extern bool ExecCheckOneRelPerms(RTEPermissionInfo *perminfo);
+extern void CheckValidResultRelNew(ResultRelInfo *resultRelInfo, CmdType operation,
+								   List *mergeActions,
+								   OnConflictAction onConflictAction);
 extern void CheckValidResultRel(ResultRelInfo *resultRelInfo, CmdType operation,
 								List *mergeActions);
 extern void InitResultRelInfo(ResultRelInfo *resultRelInfo,
diff --git a/src/test/regress/expected/publication.out b/src/test/regress/expected/publication.out
index 5d7d837afc6..b2593d4af44 100644
--- a/src/test/regress/expected/publication.out
+++ b/src/test/regress/expected/publication.out
@@ -1768,6 +1768,29 @@ MERGE INTO testpub_merge_pk USING testpub_merge_no_ri s ON s.a >= 1
 DROP PUBLICATION pub1;
 DROP TABLE testpub_merge_no_ri;
 DROP TABLE testpub_merge_pk;
+-- Test that the INSERT ON CONFLICT command correctly checks REPLICA IDENTITY
+-- when the target table is published.
+CREATE TABLE testpub_insert_onconfl_no_ri (a int unique, b int);
+CREATE TABLE testpub_insert_onconfl_parted (a int unique, b int) PARTITION by RANGE (a);
+CREATE TABLE testpub_insert_onconfl_part_no_ri PARTITION OF testpub_insert_onconfl_parted FOR VALUES FROM (1) TO (10);
+SET client_min_messages = 'ERROR';
+CREATE PUBLICATION pub1 FOR ALL TABLES;
+RESET client_min_messages;
+-- fail - missing REPLICA IDENTITY
+INSERT INTO testpub_insert_onconfl_no_ri VALUES (1, 1) ON CONFLICT (a) DO UPDATE SET b = 2;
+ERROR:  cannot update table "testpub_insert_onconfl_no_ri" because it does not have a replica identity and publishes updates
+HINT:  To enable updating the table, set REPLICA IDENTITY using ALTER TABLE.
+-- ok - no updates
+INSERT INTO testpub_insert_onconfl_no_ri VALUES (1, 1) ON CONFLICT DO NOTHING;
+-- fail - missing REPLICA IDENTITY in partition testpub_insert_onconfl_no_ri
+INSERT INTO testpub_insert_onconfl_parted VALUES (1, 1) ON CONFLICT (a) DO UPDATE SET b = 2;
+ERROR:  cannot update table "testpub_insert_onconfl_part_no_ri" because it does not have a replica identity and publishes updates
+HINT:  To enable updating the table, set REPLICA IDENTITY using ALTER TABLE.
+-- ok - no updates
+INSERT INTO testpub_insert_onconfl_parted VALUES (1, 1) ON CONFLICT DO NOTHING;
+DROP PUBLICATION pub1;
+DROP TABLE testpub_insert_onconfl_no_ri;
+DROP TABLE testpub_insert_onconfl_parted;
 RESET SESSION AUTHORIZATION;
 DROP ROLE regress_publication_user, regress_publication_user2;
 DROP ROLE regress_publication_user_dummy;
diff --git a/src/test/regress/sql/publication.sql b/src/test/regress/sql/publication.sql
index c91c92c14cd..c915b3c392c 100644
--- a/src/test/regress/sql/publication.sql
+++ b/src/test/regress/sql/publication.sql
@@ -1135,6 +1135,32 @@ DROP PUBLICATION pub1;
 DROP TABLE testpub_merge_no_ri;
 DROP TABLE testpub_merge_pk;
 
+-- Test that the INSERT ON CONFLICT command correctly checks REPLICA IDENTITY
+-- when the target table is published.
+CREATE TABLE testpub_insert_onconfl_no_ri (a int unique, b int);
+CREATE TABLE testpub_insert_onconfl_parted (a int unique, b int) PARTITION by RANGE (a);
+CREATE TABLE testpub_insert_onconfl_part_no_ri PARTITION OF testpub_insert_onconfl_parted FOR VALUES FROM (1) TO (10);
+
+SET client_min_messages = 'ERROR';
+CREATE PUBLICATION pub1 FOR ALL TABLES;
+RESET client_min_messages;
+
+-- fail - missing REPLICA IDENTITY
+INSERT INTO testpub_insert_onconfl_no_ri VALUES (1, 1) ON CONFLICT (a) DO UPDATE SET b = 2;
+
+-- ok - no updates
+INSERT INTO testpub_insert_onconfl_no_ri VALUES (1, 1) ON CONFLICT DO NOTHING;
+
+-- fail - missing REPLICA IDENTITY in partition testpub_insert_onconfl_no_ri
+INSERT INTO testpub_insert_onconfl_parted VALUES (1, 1) ON CONFLICT (a) DO UPDATE SET b = 2;
+
+-- ok - no updates
+INSERT INTO testpub_insert_onconfl_parted VALUES (1, 1) ON CONFLICT DO NOTHING;
+
+DROP PUBLICATION pub1;
+DROP TABLE testpub_insert_onconfl_no_ri;
+DROP TABLE testpub_insert_onconfl_parted;
+
 RESET SESSION AUTHORIZATION;
 DROP ROLE regress_publication_user, regress_publication_user2;
 DROP ROLE regress_publication_user_dummy;
-- 
2.51.0.windows.1

